function data_gui3_demo_constraint
    data_gui3(@demoinit1); % init data stucture
end

function [data redraw]= demoinit1( data, redraw ) % init callback
    % maintained variable definition:
    i = cell( {
        % variable name; default value; validation; callback 
        { 'data.value'  ''   @constraint_check @valueHasNewValue}
        { 'data.value123' 1 [] @constraint_has_changed}
        { 'data.statustext' ' ' }
    });
    data = data.CALL.addData(data, i); % add to data strukture
    
    data = data.CALL.addDataErrorCB(data, @dataErrorCB);
    
    % gui element definition:
    g = cell( {
        % obligation definitions                                        optional definitions:
        %                'tagname'      'parent'                        'property name1' 'property value1' 'name 2' 'value 2'
        { 'figure'       'demo1fig'                                     'Name' 'Data gui3 lib demo constraint'}
        { 'edittext'     'editfield'    'demo1fig' 'data.value'          }
        { 'radiogroup'   'radiogroup'   'demo1fig' 'data.value123'  { 'String' 'Integer' 'Numeric'} 'Title' 'Constraint' }
        { 'statictext'   'statusfield'  'demo1fig' 'data.statustext' }
        } );
    data = data.CALL.addGui(data, g); % create gui elements

    layout = {{ 26 26 26 };{ 'radiogroup_1' 'radiogroup_2' 'radiogroup_3' }};
    layout = {{ 'radiogroup' } {layout}};
    layout = {{ 0 30 10 30 10 100 0 };{ [] 'statusfield' [] 'editfield' [] layout [] }};
    layout = {{ 0 300 0 } { [] layout [] }};
    data = data.CALL.addLayout( data, 'demo1fig', layout ); % use layout 
end

function [data redraw] = valueHasNewValue(data, redraw, event) %#ok<INUSD>
    switch data.value123
        case 1
            data.statustext = [ 'OK: ' num2str(data.value) ' is numeric'];
        case 2
            data.statustext = [ 'OK: ' num2str(data.value) ' is integer'];
        case 3
            data.statustext = [ 'OK: ' data.value ' is string'];
        otherwise
            data.statustext = 'WTF is data.value123 ?';
    end
end

function [data redraw] = constraint_has_changed(data, redraw, event) %#ok<INUSD>
    data.statustext = 'constraint changed';
    data.value = '';
end

function [data redraw] = dataErrorCB(data, redraw, event)
    data.statustext = ['Error: ' event.error];
end

function [data value error] = constraint_check(data, value, error)
    if isempty(value); return; end
    switch data.value123
        case 1
            if isnumeric(value); return; end % allready numeric
            value = str2double(value);
            if isnan(value); error = 'value is not numeric'; end
        case 2
            if isnumeric(value) ; return; end % allready numeric
            value = str2double(value);
            if isnan(value); error = 'value is not an integer'; end
            if fix(value) ~= value; error = 'value is not an integer'; end
        case 3
            if ~ischar(value); error = 'value is not a string'; end
        otherwise
            error = 'value123 is undefined';
    end
end
