function data_gui3_demo_popup_3
    data_gui3(@demoinit); % init data stucture

function [data,redraw]= demoinit( data, redraw ) % init callback
    i = cell( {
        { 'data.value'      1                   [1 3]  @updatePlot }
        { 'data.config1'    'Default config'    []     @conf1_cb   }
        { 'data.config2'    'Two entries'       []     @conf23_cb  }
        { 'data.config3'    'Four entries'      []     @conf23_cb  }
        { 'data.poplist'    { 'P1' 'P2' 'P3' }                     }
        { 'data.boxlist'    { 'B1' 'B2' 'B3' }                     }
        { 'data.statustext' 'Ausgabe'                              }
    });
    data = data.CALL.addData(data, i); % add to data strukture
    
    g = cell( {
        { 'figure'      'demo1fig'                                                  'Name' 'Data gui3 lib demo popup'}
        { 'popupbox'    'popup1'        'demo1fig'  'data.value'    'data.poplist'  }
        { 'listbox'     'list1'         'demo1fig'  'data.value'    'data.boxlist'  }
        { 'statictext'   'statusfield'  'demo1fig'  'data.statustext'    }
        { 'pushbutton'   'conf1'        'demo1fig'  'data.config1'    }
        { 'pushbutton'   'conf2'        'demo1fig'  'data.config2'    }
        { 'pushbutton'   'conf3'        'demo1fig'  'data.config3'    }
        } );
    data = data.CALL.addGui(data, g); % create gui elements

    layout = {{ 0 150 0 150 0 } { [] 'list1' [] 'popup1' [] }};
    layout_b = {{ 0 150 0  150 0 150 0 } {[] 'conf1' [] 'conf2' [] 'conf3' []}};
    layout = {{ 30 5 30 0 200 0};{ 'statusfield' [] layout_b [] layout []}};
    data = data.CALL.addLayout( data, 'demo1fig', layout ); % use layout

function [data,redraw] = updatePlot( data, redraw, event ) %#ok<INUSD>
    data.statustext = ['Output: ' num2str(data.value) ];

function [data,redraw] = conf1_cb( data, redraw, event ) %#ok<INUSD>
    data = data.CALL.defaultValue( data, 'data.poplist' );
    data = data.CALL.defaultValue( data, 'data.boxlist' );   
    data = data.CALL.updateConstrain(data, 'data.value', [1 3]);
    data.value = 1;
    data.statustext = '';

function [data,redraw] = conf23_cb( data, redraw, event )
    poplist = { 'P1' 'P2' 'P3' 'P4'};
    boxlist = { 'B1' 'B2' 'B3' 'B4'};
    switch event.valueString
        case 'data.config2'
            poplist = poplist(1:2);
            boxlist = boxlist(1:2);
        case 'data.config3'
        otherwise
            return
    end
    data = data.CALL.updateConstrain(data, 'data.value', [1 size(poplist,2)]);
    if data.value > size(poplist,2); data.value = size(poplist,2); end
    data.poplist = poplist;
    data.boxlist = boxlist;
    data.statustext = '';
    